//----------------------------------------------------------------------
// Copyright 2011 Ciaran McHale.
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions.
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.  
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
// BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
// ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
// CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//----------------------------------------------------------------------

#ifndef LOGGER_H_
#define LOGGER_H_


class Logger
{
public:
	enum LogLevel {
		NO_LOGS_LEVEL = 0,
		ERROR_LEVEL   = 1,
		WARN_LEVEL    = 2,
		INFO_LEVEL    = 3,
		DEBUG_LEVEL   = 4
	};

	static void error(LogLevel logLevel, const char * msg);
	static void warn(LogLevel logLevel, const char * msg);
	static void info(LogLevel logLevel, const char * msg);
	static void debug(LogLevel logLevel, const char * msg);
};


//--------
// Singleton object
//--------
extern Logger logger;

#endif
